Index: /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionIndex.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionIndex.java	(revision 4932)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionIndex.java	(revision 4932)
@@ -0,0 +1,195 @@
+/**
+ *#########################################################################
+ *
+ * A component of the Gatherer application, part of the Greenstone digital
+ * library suite from the New Zealand Digital Library Project at the
+ * University of Waikato, New Zealand.
+ *
+ * Author: John Thompson, Greenstone Digital Library, University of Waikato
+ *
+ * Copyright (C) 1999 New Zealand Digital Library Project
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *########################################################################
+ */
+package org.greenstone.gatherer.cdm;
+/**************************************************************************************
+ * Written:     04/07/03
+ * Revised:     
+ **************************************************************************************/
+import java.util.*;
+import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
+import org.greenstone.gatherer.cdm.CollectionDesignManager;
+import org.greenstone.gatherer.cdm.CollectionMeta;
+import org.greenstone.gatherer.cdm.DOMProxyListEntry;
+import org.greenstone.gatherer.msm.MSMUtils;
+import org.greenstone.gatherer.util.StaticStrings;
+import org.greenstone.gatherer.util.Utility;
+import org.w3c.dom.*;
+/** This class encapsulates a single indexing pair.
+ * @author John Thompson, Greenstone Digital Library, University of Waikato
+ * @version 2.4
+ */
+public class SubcollectionIndex
+    implements Comparable, DOMProxyListEntry {
+
+    private ArrayList sources = null;
+    /** The element this index is based upon. */
+    private Element element = null;
+    /** The unique, if cryptic, identifier of an index. */
+    private String id = null;
+
+    /** Default constructor, which should only be used during DOMProxyListModel creation. */
+    public SubcollectionIndex() {
+    }
+
+    /** Constructor. */
+    public SubcollectionIndex(Element element) {
+	this.element = element;
+    }
+
+    public SubcollectionIndex(Object[] raw_sources) {
+	this.sources = new ArrayList();
+	// Create a new element
+	Document document = CollectionDesignManager.collect_config.document;
+	element = document.createElement(CollectionConfiguration.INDEX_ELEMENT);
+	// For each source add a content element
+	int size = raw_sources.length;
+	for(int i = 0; i < size; i++) {
+	    Subcollection subcollection = (Subcollection) raw_sources[i];
+	    String subcollection_name = subcollection.getName();
+	    sources.add(subcollection_name);
+	    Element content_element = document.createElement(CollectionConfiguration.CONTENT_ELEMENT);
+	    content_element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, subcollection_name);
+	    element.appendChild(content_element);
+	    content_element = null;
+	}
+	document = null;
+    }
+
+    /** Method to compare two indexes.
+     * @param object The other index as an <strong>Object</strong>.
+     * @return An <i>int</i> which indicates how the indexes compare.
+     * @see java.lang.String
+     */
+    public int compareTo(Object object) {
+	return id.compareTo(((SubcollectionIndex)object).getID());
+    }
+    
+    public DOMProxyListEntry create(Element element) {
+	return new SubcollectionIndex(element);
+    }
+
+    /** Method to test for the equality of two indexes.
+     * @param object The other index as an <strong>Object</strong>.
+     * @return A <i>boolean</i> which is <i>true</i> if the two indexes are equal, <i>false</i> otherwise.
+     */
+    public boolean equals(Object object) {
+	return (compareTo(object) == 0);
+    }
+    
+    public Element getElement() {
+	return element;
+    }
+
+    public String getID() {
+	if(id == null) {
+	    StringBuffer id_buffer = new StringBuffer();
+	    // Write data information. Retrieve each of the content sources and add them in a comma separated list.
+	    ArrayList sources = getSources();
+	    int sources_size = sources.size();
+	    for(int i = 0; i < sources_size; i++) {
+		id_buffer.append((String)sources.get(i));
+		id_buffer.append(StaticStrings.COMMA_CHARACTER);
+	    }
+	    sources = null;
+	    id = id_buffer.substring(0, id_buffer.length() - 1);
+	}
+	return id;
+    }
+
+    /** Retrieve the sources of this index.
+     * @return the sources as an ArrayList
+     */
+    public ArrayList getSources() {
+	if(sources == null) {
+	    sources = new ArrayList();
+	    NodeList content_elements = element.getElementsByTagName(CollectionConfiguration.CONTENT_ELEMENT);
+	    int content_elements_length = content_elements.getLength();
+	    for(int i = 0; i < content_elements_length; i++) {
+		Element content_element = (Element) content_elements.item(i);
+		sources.add(content_element.getAttribute(CollectionConfiguration.NAME_ATTRIBUTE));
+	    }
+	    content_elements = null;
+	    Collections.sort(sources);
+	}
+	return sources;
+    }
+
+    public boolean isAssigned() {
+	return (element != null && !element.getAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE).equals(CollectionConfiguration.FALSE_STR));
+    }
+
+    public void setAssigned(boolean assigned) {
+	if(element != null) {
+	    element.setAttribute(CollectionConfiguration.ASSIGNED_ATTRIBUTE, (assigned ? CollectionConfiguration.TRUE_STR : CollectionConfiguration.FALSE_STR));
+	}
+    }
+
+    public void setElement(Element element) {
+	this.element = element;
+	this.id = null;
+	this.sources = null;
+    }
+
+    /** Method to set the sources for this index which can only be used for the default index.
+     * @param sources an ArrayList of source names
+     */
+    public void setSources(ArrayList sources) {
+	if(element != null) {
+	    // Erase old sources
+	    MSMUtils.clear(element);
+	    // For each entry in the sources array add a new content element.
+	    int size = sources.size();
+	    for(int i = 0; i < size; i++) {
+		Element content_element = element.getOwnerDocument().createElement(CollectionConfiguration.CONTENT_ELEMENT);
+		content_element.setAttribute(CollectionConfiguration.NAME_ATTRIBUTE, (String) sources.get(i));
+		element.appendChild(content_element);
+		content_element = null;
+	    }
+	    this.id = null; // Regenerate ID.
+	    this.sources = sources;
+	}
+	else {
+	    Gatherer.println("Error! Called setSource() of index other than the default.");
+	}
+    }
+
+    /** Method to turn this object into a string representation ready to be placed in the collection configuration file.
+     * @return A <strong>String</strong> containing the information of this class.
+     */
+    public String toString() {
+	String id = getID();
+	StringBuffer text = new StringBuffer(id);
+	CollectionMeta metadatum = CollectionDesignManager.collectionmeta_manager.getMetadatum(StaticStrings.STOP_CHARACTER + id, false);
+	if(metadatum != null) {
+	    text.append(" \"");
+	    text.append(metadatum.getValue());
+	    text.append("\"");
+	}
+	return text.toString();
+    }
+}
Index: /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionIndexManager.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionIndexManager.java	(revision 4932)
+++ /trunk/gli/src/org/greenstone/gatherer/cdm/SubcollectionIndexManager.java	(revision 4932)
@@ -0,0 +1,425 @@
+/**
+ *#########################################################################
+ *
+ * A component of the Gatherer application, part of the Greenstone digital
+ * library suite from the New Zealand Digital Library Project at the
+ * University of Waikato, New Zealand.
+ *
+ * Author: John Thompson, Greenstone Digital Library, University of Waikato
+ *
+ * Copyright (C) 1999 New Zealand Digital Library Project
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *########################################################################
+ */
+package org.greenstone.gatherer.cdm;
+
+import java.awt.*;
+import java.awt.event.*;
+import java.util.*;
+import javax.swing.*;
+import javax.swing.event.*;
+import org.greenstone.gatherer.Gatherer;
+import org.greenstone.gatherer.cdm.CollectionConfiguration;
+import org.greenstone.gatherer.cdm.CollectionDesignManager;
+import org.greenstone.gatherer.cdm.Control;
+import org.greenstone.gatherer.cdm.DOMProxyListModel;
+import org.greenstone.gatherer.cdm.Subcollection;
+import org.greenstone.gatherer.cdm.SubcollectionIndex;
+import org.greenstone.gatherer.msm.ElementWrapper;
+import org.greenstone.gatherer.util.ExclusiveListSelectionListener;
+import org.greenstone.gatherer.util.StaticStrings;
+import org.w3c.dom.*;
+/** This class maintains a list of indexes partitions for the purpose of defining subcollections.
+ * @author John Thompson, Greenstone Digital Library, University of Waikato
+ * @version 2.4
+ */
+public class SubcollectionIndexManager
+    extends DOMProxyListModel {
+
+    private Control controls;
+    private DOMProxyListModel model;
+    private SubcollectionIndex default_index;
+
+    /** Constructor. */
+    public SubcollectionIndexManager(Element subindexes) {
+	super(subindexes, CollectionConfiguration.INDEX_ELEMENT, new SubcollectionIndex());
+	Gatherer.println("SubcollectionIndexManager: " + getSize() + " subcollection indexes parsed.");
+	model = this;
+	// Parse and retrieve the default index
+	NodeList default_index_elements = CollectionDesignManager.collect_config.getDocumentElement().getElementsByTagName(CollectionConfiguration.SUBCOLLECTION_DEFAULT_INDEX_ELEMENT);
+	if(default_index_elements.getLength() > 0) {
+	    default_index = new SubcollectionIndex((Element)default_index_elements.item(0));
+	}
+    }
+
+    /** Method to add a subindex.
+     * @param subindex a SubcollectionIndex
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.collection.CollectionManager
+     */
+    public void addSubcollectionIndex(SubcollectionIndex subindex) {
+	if(!contains(subindex)) {
+	    add(getSize(), subindex);
+	    Gatherer.c_man.configurationChanged();
+	}
+    }
+
+    public void destroy() {
+	if(controls != null) {
+	    controls.destroy();
+	    controls = null;
+	}
+	default_index = null;
+	model = null;
+    }
+
+    public Control getControls() {
+	if(controls == null) {
+	    controls = new SubcollectionIndexControl();
+	}
+	return controls;
+    }
+
+    /** Method to retrieve the default index.
+     * @return the default Index, or null if no such index assigned
+     */
+    public SubcollectionIndex getDefaultSubcollectionIndex() {
+	if(default_index != null && default_index.isAssigned()) {
+	    return default_index;
+	}
+	else {
+	    return null;
+	}
+    }
+
+    /** Retrieve a certain subindex given its name.
+     * @param id the String identifier of a subcollectionindex
+     * @return the SubcollectionIndex requested or null if no such subindex
+     */
+    public SubcollectionIndex getSubcollectionIndex(String id) {
+	int size = getSize();
+	for(int i = 0; i < size; i++) {
+	    SubcollectionIndex subindex = (SubcollectionIndex) getElementAt(i);
+	    if(subindex.getID().equals(id)) {
+		return subindex;
+	    }
+	}
+	return null;
+    }
+
+    /** Method to get all of the subindexes set.
+     * @return an ArrayList containing all the defined indexes
+     */
+    public ArrayList getSubcollectionIndexes() {
+	return children();
+    }
+
+    /** Method to remove a certain subindex.
+     * @param subindex the Index you wish to remove
+     * @see org.greenstone.gatherer.Gatherer
+     * @see org.greenstone.gatherer.collection.CollectionManager
+     */
+    public void removeSubcollectionIndex(SubcollectionIndex subindex) {
+	if(subindex != null) {
+	    // Remove any current metadata from this index
+	    CollectionDesignManager.collectionmeta_manager.removeMetadata(StaticStrings.STOP_CHARACTER + subindex.getID());
+	    // Check if the index removed happens to be the default index
+	    if(default_index != null && default_index.equals(subindex)) {
+		default_index.setAssigned(false);
+	    }
+	    // Remove the index
+	    remove(subindex);
+	    Gatherer.c_man.configurationChanged();
+	}
+    }
+    /** Method to remove all of the subindexes that contain a certain subcollection.
+     * @param sub the Subcollection that has been removed
+     * @see org.greenstone.gatherer.cdm.Subcollection
+     * @see org.greenstone.gatherer.cdm.SubcollectionIndex
+     */
+    public void removeSubcollectionIndexes(Subcollection subcollection) {
+	String subcollection_name = subcollection.getName();
+	int size = getSize();
+	for(int i = size - 1; i >= 0; i--) {
+	    SubcollectionIndex subindex = (SubcollectionIndex)getElementAt(i);
+	    if(subindex.getSources().contains(subcollection_name)) {
+		removeSubcollectionIndex(subindex);
+	    }
+	    subindex = null;
+	}
+	subcollection_name = null;
+    }
+
+    /** Method to set the default subcollection index.
+	  * @param subcollection The <strong>Subcollection</strong> to use as the default index.
+	  * @see org.greenstone.gatherer.Gatherer
+	  * @see org.greenstone.gatherer.collection.CollectionManager
+	  */
+    public void setDefaultSubcollectionIndex(SubcollectionIndex index) {
+	if(index != null) {
+	    if(default_index == null) {
+		// Create the default index element, and place immediately after indexes element.
+		Element default_index_element = root.getOwnerDocument().createElement(CollectionConfiguration.SUBCOLLECTION_DEFAULT_INDEX_ELEMENT);
+		default_index = new SubcollectionIndex(default_index_element);
+		Node target_node = CollectionConfiguration.findInsertionPoint(default_index_element);
+		if(target_node != null) {
+		    root.getOwnerDocument().getDocumentElement().insertBefore(default_index_element, target_node);
+		}
+		else {
+		    root.getOwnerDocument().getDocumentElement().appendChild(default_index_element);
+		}
+	    }
+	    default_index.setAssigned(true);
+	    default_index.setSources(index.getSources());
+	}
+	else {
+	    if(default_index != null) {
+		default_index.setAssigned(false);
+	    }
+	}
+	Gatherer.c_man.configurationChanged();
+    }
+
+    /** Method to retrieve a phrase from the dictionary based on a key.
+     * @param key A <strong>String</strong> used to find the correct phrase.
+     * @param args A <strong>String[]</strong> of arguments used in formatting and filling out the phrase.
+     * @return A <strong>String</strong> containing the correct phrase with the correct formatting.
+     */
+    private String get(String key) {
+	if(key.indexOf(".") == -1) {
+	    key = "CDM.SubcollectionIndexManager." + key;
+	}
+	return Gatherer.dictionary.get(key);
+    }
+
+    private class SubcollectionIndexControl
+	extends JPanel
+	implements Control {
+
+	private JButton add_index_button;
+	private JButton clear_default_button;
+	private JButton remove_index_button;
+	private JButton set_default_button;
+	private JList subcollection_list;
+	private JList subcollectionindexes_list;
+	private JTextField default_value_field;
+	private JTextField subcollectionindex_name_field;
+
+	public SubcollectionIndexControl() {
+	    super();
+	    // Creation
+	    JPanel subindex_pane = new JPanel();
+	    JPanel subcollection_panel = new JPanel();
+	    JPanel subindex_name_panel = new JPanel();
+	    JLabel subindex_name_label = new JLabel(get("PartitionName"));
+	    subcollectionindex_name_field = new JTextField();
+
+	    add_index_button = new JButton(get("Add_Subindex"));
+	    add_index_button.setMnemonic(KeyEvent.VK_A);
+	    add_index_button.setEnabled(false);
+
+	    JPanel button_pane = new JPanel();
+
+	    clear_default_button = new JButton(get("Clear_Default_Subindex"));
+	    clear_default_button.setMnemonic(KeyEvent.VK_C);
+	    if(default_index == null) {
+		clear_default_button.setEnabled(false);
+	    }
+
+	    JLabel default_label = new JLabel(get("Default_Subindex"));
+	    JPanel default_pane = new JPanel();
+	    if(default_index == null) {
+		default_value_field = new JTextField();
+	    }
+	    else {
+		default_value_field = new JTextField(default_index.toString());
+	    }
+	    default_value_field.setBackground(Gatherer.config.getColor("coloring.collection_tree_background", false));
+	    default_value_field.setEditable(false);
+	    remove_index_button = new JButton(get("Remove_Subindex"));
+	    remove_index_button.setMnemonic(KeyEvent.VK_R);
+	    set_default_button = new JButton(get("Set_Default_Subindex"));
+	    set_default_button.setMnemonic(KeyEvent.VK_S);
+	    JLabel subcollection_label = new JLabel(get("Subcollection"));
+	    subcollection_list = new JList(CollectionDesignManager.subcollection_manager);
+	    JPanel list_pane = new JPanel();
+	    JLabel subindexes_label = new JLabel(get("Subindexes"));
+	    subcollectionindexes_list = new JList(model);
+	    subcollectionindexes_list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
+	    JPanel subindexes_pane = new JPanel();
+
+	    // Add listeners
+	    ExclusiveListSelectionListener ell = new ExclusiveListSelectionListener();
+	    ell.add(subcollection_list);
+	    ell.add(subcollectionindexes_list);
+	    add_index_button.addActionListener(new AddSubIndexListener());
+	    clear_default_button.addActionListener(new ClearDefaultSubIndexListener());
+	    remove_index_button.addActionListener(new RemoveSubIndexListener());
+	    set_default_button.addActionListener(new SetDefaultSubIndexListener());
+
+	    subcollectionindex_name_field.getDocument().addDocumentListener(new SubcollectionIndexListener());
+	    subcollection_list.addListSelectionListener(new SubcollectionIndexListener());
+
+	    // Layout
+	    subindex_name_panel.setLayout(new BorderLayout());
+	    subindex_name_panel.add(subindex_name_label, BorderLayout.WEST);
+	    subindex_name_panel.add(subcollectionindex_name_field, BorderLayout.CENTER);
+
+	    list_pane.setLayout(new BorderLayout());
+	    list_pane.add(subcollection_label, BorderLayout.NORTH);
+	    list_pane.add(new JScrollPane(subcollection_list), BorderLayout.CENTER);
+	    
+	    subcollection_panel.setLayout(new BorderLayout());
+	    subcollection_panel.add(subindex_name_panel, BorderLayout.NORTH);
+	    subcollection_panel.add(list_pane, BorderLayout.CENTER);
+
+	    default_label.setBorder(BorderFactory.createEmptyBorder(0,0,0,5));
+
+	    default_pane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(5,5,5,5), BorderFactory.createRaisedBevelBorder()), BorderFactory.createEmptyBorder(2,2,2,2)));
+	    default_pane.setLayout(new BorderLayout());
+	    default_pane.add(default_label, BorderLayout.WEST);
+	    default_pane.add(default_value_field, BorderLayout.CENTER);
+
+	    subindexes_pane.setLayout(new BorderLayout());
+	    subindexes_pane.add(subindexes_label, BorderLayout.NORTH);
+	    subindexes_pane.add(new JScrollPane(subcollectionindexes_list), BorderLayout.CENTER);
+	    subindexes_pane.add(default_pane, BorderLayout.SOUTH);
+	    
+	    subindex_pane.setLayout(new GridLayout(1,2,5,0));
+	    subindex_pane.add(subcollection_panel);
+	    subindex_pane.add(subindexes_pane);
+
+	    button_pane.setLayout(new GridLayout(2,2));
+	    button_pane.add(add_index_button);
+	    button_pane.add(remove_index_button);
+	    button_pane.add(clear_default_button);
+	    button_pane.add(set_default_button);
+	    
+	    setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
+	    setLayout(new BorderLayout());
+	    add(subindex_pane, BorderLayout.CENTER);
+	    add(button_pane, BorderLayout.SOUTH);
+	}
+
+	public void destroy() {
+	}
+
+	public void gainFocus() {
+	}
+
+	public void loseFocus() {
+	}
+
+	/** Listens for actions apon the 'add subindex' button in the SubcollectionManager controls, and if detected calls the addSubindex method of the manager with a newly created subindex. */
+	private class AddSubIndexListener
+	    implements ActionListener {
+	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a series of subcollections selected, and if so build an new subindex based apon them.
+	     * @param event An <strong>ActionEvent</strong> containing information about the event.
+	     * @see org.greenstone.gatherer.cdm.SubIndex
+	     */
+	    public void actionPerformed(ActionEvent event) {
+		if(!subcollection_list.isSelectionEmpty() && subcollectionindex_name_field.getText().length() > 0) {
+		    SubcollectionIndex subindex = new SubcollectionIndex(subcollection_list.getSelectedValues());
+		    addSubcollectionIndex(subindex);
+		    // Add the subindexes name.
+		    CollectionMeta metadatum = new CollectionMeta("." + subindex.getID());
+		    metadatum.setValue(subcollectionindex_name_field.getText());
+		    CollectionDesignManager.collectionmeta_manager.addMetadatum(metadatum);
+		}
+	    }
+	}
+
+	/** Listens for actions apon the 'clear default subindex' button in the SubcollectionManager controls, and if detected calls the setDefaultSubcollectionIndex() method of the manager with <i>null</i>. */
+	private class ClearDefaultSubIndexListener
+	    implements ActionListener {
+	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to clear the default subindex.
+	     * @param event An <strong>ActionEvent</strong> containing information about the event.
+	     */
+	    public void actionPerformed(ActionEvent event) {
+		setDefaultSubcollectionIndex(null);
+		clear_default_button.setEnabled(false);
+		default_value_field.setText("");
+	    }
+	}
+
+	/** Listens for actions apon the 'remove subindex' button in the SubcollectionManager controls, and if detected calls the removeSubcollectionIndex method of the manager with the SubcollectionIndex selected for removal. */
+	private class RemoveSubIndexListener
+	    implements ActionListener {
+	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a subindex selected, and if so remove it.
+	     * @param event An <strong>ActionEvent</strong> containing information about the event.
+	     * @see org.greenstone.gatherer.cdm.SubIndex
+	     */
+	    public void actionPerformed(ActionEvent event) {
+		if(!subcollectionindexes_list.isSelectionEmpty()) {
+		    removeSubcollectionIndex((SubcollectionIndex)subcollectionindexes_list.getSelectedValue());
+		}
+	    }
+	}
+	/** Listens for actions apon the 'set default subindex' button in the SubcollectionManager controls, and if detected calls the setDefaultSubcollectionIndex method of the manager with the SubIndex selected for default. */
+	private class SetDefaultSubIndexListener
+	    implements ActionListener {
+	    /** Any implementation of ActionListener must include this method so we can be informed when an action has been performed on one of our target controls. In this case we want to check if they have a subindex selected, and if so set it as default.
+	     * @param event An <strong>ActionEvent</strong> containing information about the event.
+	     * @see org.greenstone.gatherer.cdm.DefaultSubIndex
+	     * @see org.greenstone.gatherer.cdm.SubIndex
+	     */
+	    public void actionPerformed(ActionEvent event) {
+		if(!subcollectionindexes_list.isSelectionEmpty()) {
+		    setDefaultSubcollectionIndex((SubcollectionIndex)subcollectionindexes_list.getSelectedValue());
+		    clear_default_button.setEnabled(true);
+		    default_value_field.setText(default_index.toString());
+		}
+	    }
+	}
+	
+	private class SubcollectionIndexListener
+	    implements DocumentListener, ListSelectionListener {
+
+	    /** Gives notification that an attribute or set of attributes changed. */
+	    public void changedUpdate(DocumentEvent e) {
+		update();
+	    }
+	    /** Gives notification that there was an insert into the document. */
+	    public void insertUpdate(DocumentEvent e) {
+		update();
+	    }
+	    /** Gives notification that a portion of the document has been removed. */
+	    public void removeUpdate(DocumentEvent e) {
+		update();
+	    }
+
+	    public void valueChanged(ListSelectionEvent event) {
+		if(!event.getValueIsAdjusting()) {
+		    update();
+		}
+	    }
+
+	    /** The text area has changed in some way. Given that this can only happed when we are editing or adding a text fragment we better respond appropriately. */
+	    private void update() {
+		if(!subcollection_list.isSelectionEmpty() && subcollectionindex_name_field.getText().length() > 0) {
+		    if (getSubcollectionIndex(subcollectionindex_name_field.getText()) == null) {
+			add_index_button.setEnabled(true);
+		    } else {
+			add_index_button.setEnabled(false);
+		    }
+		}
+		else {
+		    add_index_button.setEnabled(false);
+		}
+	    }
+	}
+    }
+}
